//+------------------------------------------------------------------+
//|                                       Visual_Handle_Tranning.mq4 |
//+------------------------------------------------------------------+

//    
//      BUY
//       SELL
//  b - buy
//  s - sell
//

//
//          
//    F9       4    !!!    
//     

#property copyright "Copyright  2005, klot"
#property link      "klot@mail.ru"
#define MAGICEXP 00000001
#include <stdlib.mqh>
#include <WinUser32.mqh>
#import "IdleLib.dll"
int GetLastKeyWP();
int IdleLibInit();
int IdleLibUnInit();
string GetActiveWndName();
#import


#include <VisualTestingTools.mq4>


//--------------------------------------------------------------------
extern double Lots= 0.1;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 

	vTerminalInit();


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//|    Buy   "b"                    |
//|     Sell   "s"                  |
//|       "c"                    |
//+------------------------------------------------------------------+
int start()
  {
   //-----------------------------------------------------------------------
   IdleLibInit();// Dll    
   int lastkey=GetLastKeyWP();//  . 
   string lastwnd=GetActiveWndName();//  Metatrader   
   int pos=Check_for_open_pos(); // ,    
   
   if ((lastkey!=0) && (lastwnd!="") && (lastkey==66) &&  pos != 1  )  //    Buy  "b"- 66
   {             
      buy_open(0,0);
    //Print("  =",lastkey,"   ",lastwnd);
   }  
   if ((lastkey!=0) && (lastwnd!="") && (lastkey==83) &&  pos!=-1 )  //    Sell  "s"- 83
   {             
      sell_open(0,0);
    // Print("  =",lastkey,"   ",lastwnd);
   }  
   if ((lastkey!=0) && (lastwnd!="") && (lastkey == 40) ) // && (lastkey==67) )  //      "c"- 67
   {             
     close_order_sell(0,0);
    // Print("  =",lastkey,"   ",lastwnd);
   }  

   if ((lastkey!=0) && (lastwnd!="") && (lastkey == 38) ) // && (lastkey==67) )  //      "c"- 67
   {             
     close_order_buy(0,0);
    // Print("  =",lastkey,"   ",lastwnd);
   }  
//if (lastkey!=0)
//  Print(" "+lastkey);
   //-----------------------------------------------------------------------


vTerminalRefresh();


   return(0);
  }
//+------------------------------------------------------------------+
//---------------------------------------------------------------------
void buy_open(double TP,double SL)
{
   int ticket,ExtShotsCounter,lasterror;
   ticket=OrderSend(Symbol(),OP_BUY,Lots,NormalizeDouble(Ask,4),5,NormalizeDouble(SL,4),NormalizeDouble(TP,4),"",MAGICEXP,0,Aquamarine);
      if(ticket>0)
       { 
        if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
        Print("BUY order opened : ",OrderOpenPrice());
     //   if(!ScreenShot(ExtShotsCounter+"Open_"+Hour()+".gif",640,480)) lasterror=GetLastError();
     //   else ExtShotsCounter++;       
       }
       else Print("Error opening BUY order : ",ErrorDescription(GetLastError())); 
  return;
} 
void sell_open(double TP,double SL)
{
    int ticket,ExtShotsCounter,lasterror;
    ticket=OrderSend(Symbol(),OP_SELL,Lots,NormalizeDouble(Bid,4),5,NormalizeDouble(SL,4),NormalizeDouble(TP,4),"",MAGICEXP,0,Red);
      if(ticket>0)
       {
        if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
        Print("Sell order opened : ",OrderOpenPrice());
      }
       else Print("Error opening Sell order : ",ErrorDescription(GetLastError())); 
    return;
} 
//------------------------------------------------------------------------------------------

void close_order_buy(int k=0,int n=0)
{
   
   for( int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderMagicNumber()!=MAGICEXP || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY && (n==1 || n==0) )
        {
           if ( OrderProfit()>0 && k==1 ) OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,4),3,White);
           if ( k==0 ) OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,4),3,White);
        }
        
//      if(OrderType()==OP_SELL && (n==-1 || n==0) )
//        {
//           if ( OrderProfit()>0 && k==1 ) OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,4),3,White);
//           if ( k==0 ) OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,4),3,White);
//        }
     }
}


void close_order_sell(int k=0,int n=0)
{
   
   for( int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderMagicNumber()!=MAGICEXP || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
//      if(OrderType()==OP_BUY && (n==1 || n==0) )
//        {
//           if ( OrderProfit()>0 && k==1 ) OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,4),3,White);
//           if ( k==0 ) OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,4),3,White);
//        }
        
      if(OrderType()==OP_SELL && (n==-1 || n==0) )
        {
           if ( OrderProfit()>0 && k==1 ) OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,4),3,White);
           if ( k==0 ) OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,4),3,White);
        }
     }
}


//-----------------------------------------------------------------------------------+
int Check_for_open_pos()
{
   int ticket,cnt,pos;
   if (OrdersTotal()>0) 
   {
      for(cnt=0;cnt<=OrdersTotal();cnt++)
         {
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            if(OrderMagicNumber()!=MAGICEXP || OrderSymbol()!=Symbol()) continue;
            if(OrderType()==OP_SELL ) pos=-1; 
            if(OrderType()==OP_BUY )  pos=1;
         }
   }
 return(pos);
}
//---------------------------------------------------------------------+

